/*
 * Copyright 2012 Adaptrex, LLC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.persistence;

import com.adaptrex.core.Adaptrex;
import com.adaptrex.core.ext.data.Store;
import java.util.List;

/**
 *
 * @author
 * adaptrex
 */
public class AdaptrexSession {
    
    private Object nativeSession;
    private AdaptrexPersistence persistence;
    
    public AdaptrexSession() {
	this("");
    }
    
    public AdaptrexSession(String factoryName) {
	persistence = Adaptrex.getPersistence(factoryName);
	this.nativeSession = persistence.getNativeSession();
    }

    public Object getNativeSession() {
	return nativeSession;
    }

    public List<Object> getEntityList(Store store) {
	return persistence.getEntityList(this, store);
    }

    public Object getEntity(String entityName, Integer id) {
	return persistence.getEntity(this, entityName, id);
    }
    
    public Object getEntity(Class<?> clazz, Integer id) {
	return persistence.getEntity(this, clazz, id);
    }
    
    public Object saveEntity(Object entity) {
	return persistence.saveEntity(this, entity);
    }
    
    public Object deleteEntity(String entityName, Integer id) {
	return persistence.deleteEntity(this, entityName, id);
    }
    
    public void close() {
	persistence.closeNativeSession(nativeSession);
    }
    
}
